      PROGRAM DRIVER
C
C***********************************************************************
C*                                                                     *
C*    driver model for testing MTRXY, SKYPCF, SKYSCF, SKYSS            *
C*                                                                     *
C*    MTRXY  : requires FILEA                                          *
C*    SKYPCF : requires FILEA, FILEF and FILEB                         *
C*    SKYSCF : requires FILEA, FILEF and FILEB                         *
C*    SKYSS  : requires FILEF                                          *
C*                                                                     *
C***********************************************************************
C
C.... set limits .......................................................
C
      INTEGER          NMAXMI,NMAXMR
C
      PARAMETER        (NMAXMR = 100000)
      PARAMETER        (NMAXMI =   1000)
C
C***********************************************************************
C
C.... work variables ...................................................
C
      INTEGER          I,INFO,INRTIA(3),IPNTA1,IPNTA2,IPNTA3,IPNTA4,
     &                 IPNTA5,IPNTA6,IPNTA7,IPNTA8,IPNTM1,IPNTM2,
     &                 IPNTM3,IPNTM4,LBANDW,MCOLS,MROWS,MTYPE,
     &                 NBLOCK,NCFB,NCFT,NEQ
      DOUBLE PRECISION SIGMA
      CHARACTER*12     FILEA,FILEB,FILEF,FINFO,TEST
C
C.... arrays ...........................................................
C
      INTEGER          M(NMAXMI)
      DOUBLE PRECISION A(NMAXMR)
C
C***********************************************************************
C
      WRITE  (*,*) '                                               '
      WRITE  (*,*) '==============================================='
      WRITE  (*,*) 'driver for testing MTRXY, SKYPCF, SKYSCF, SKYSS'
      WRITE  (*,*) '==============================================='
      WRITE  (*,*) '                                               '
C
C.... read information from file 'driver.par' ..........................
C
      OPEN   (5,ERR=1,FORM='formatted',FILE='driver.par')
      READ   (5,FMT='(A12)',ERR=1) TEST
      READ   (5,FMT='(A12)',ERR=1) FILEA
      READ   (5,FMT='(A12)',ERR=1) FINFO
      READ   (5,FMT='(A12)',ERR=1) FILEB
      READ   (5,FMT='(A12)',ERR=1) FILEF
      READ   (5,FMT=*,ERR=1) MTYPE
      READ   (5,FMT=*,ERR=1) MCOLS
      READ   (5,FMT=*,ERR=1) MROWS
      READ   (5,FMT=*,ERR=1) SIGMA
      CLOSE  (5,ERR=1)
C
C.... read information from file FINFO .................................
C
      OPEN   (7,ERR=2,FORM='unformatted',FILE=FINFO)
      REWIND (7)
      READ   (7) LBANDW,NBLOCK,NCFB,NCFT,NEQ  
C
C.... define pointers for (A) ..........................................
C
      IPNTA1 = 1
      IPNTA2 = IPNTA1 + NCFB
      IPNTA3 = IPNTA2 + MAX0(NCFB,NEQ)
      IPNTA4 = IPNTA3 + NEQ 
      IPNTA5 = IPNTA4 + NEQ 
      IPNTA6 = IPNTA5 + NEQ 
      IPNTA7 = IPNTA6 + MROWS*MCOLS
      IPNTA8 = IPNTA7 + MROWS*MROWS
C
      IF ( IPNTA8 .GT. NMAXMR ) THEN
         WRITE (*,'(/A)') 'STOP: array A is not big enough'
         STOP
      END IF
C
C.... define pointers for (M) ..........................................
C
      IPNTM1 = 1
      IPNTM2 = IPNTM1 + 3*NBLOCK
      IPNTM3 = IPNTM2 + NEQ 
      IPNTM4 = IPNTM3 + MCOLS
C
      IF ( IPNTM4 .GT. NMAXMI ) THEN
         WRITE (*,'(/A)') 'STOP: array M is not big enough'
         STOP
      END IF
C
C.... prepare to perform the test ......................................
C
      WRITE  (*,*) 'testing ',TEST
      WRITE  (*,*) ' '
      WRITE  (*,*) 'semibandwidth             :',LBANDW
      WRITE  (*,*) 'number of blocks          :',NBLOCK
      WRITE  (*,*) 'number of equations       :',NEQ
      WRITE  (*,*) 'maximum number of entries :',NCFB
      WRITE  (*,*) 'total   number of entries :',NCFT
C
      READ   (7) (M(IPNTM1+I),I=0,3*NBLOCK-1)
      READ   (7) (M(IPNTM2+I),I=0,NEQ-1)      
      CLOSE  (7,ERR=2)
C
      IF      ( TEST .EQ. 'MTRXY'  ) THEN
C
C............ test MTRXY ...............................................
C
              OPEN  (5,ERR=3,FORM='formatted',FILE='driver.dat')
              READ  (5,FMT=*,ERR=3) (A(IPNTA4+I),I=0,NEQ-1)
              CLOSE (5,ERR=3)
C
              CALL MTRXY  (NEQ,NEQ,1,A(IPNTA1),A(IPNTA4),A(IPNTA5),
     &                     M(IPNTM2),M(IPNTM1),NBLOCK,MTYPE,
     &                     FILEA,10,INFO)
C
              OPEN  (6,ERR=3,FORM='formatted',FILE='driver.out')
              WRITE (6,FMT='(1P,E12.4)',ERR=4) (A(IPNTA5+I),I=0,NEQ-1)
              CLOSE (6,ERR=3)
C
      ELSE IF ( TEST .EQ. 'SKYPCF' ) THEN
C
C............ test SKYPCF ..............................................
C
              CALL SKYPCF (NEQ,M(IPNTM2),M(IPNTM1),NBLOCK,FILEA,10,
     &                     FILEF,11,FILEB,12,MTYPE,A(IPNTA1),
     &                     A(IPNTA2),A(IPNTA3),SIGMA,A(IPNTA6),
     &                     A(IPNTA7),MCOLS,MROWS,M(IPNTM3),
     &                     INRTIA,INFO)
C
              WRITE  (*,*) 'inrtia(1)                 :',INRTIA(1)
              WRITE  (*,*) 'inrtia(2)                 :',INRTIA(2)
              WRITE  (*,*) 'inrtia(3)                 :',INRTIA(3)
C
              CALL OUTPUT (A(IPNTA1),M(IPNTM2),NEQ)
C
      ELSE IF ( TEST .EQ. 'SKYSCF' ) THEN
C
C............ test SKYSCF ..............................................
C
              CALL SKYSCF (NEQ,M(IPNTM2),M(IPNTM1),NBLOCK,FILEA,10,
     &                     FILEF,11,FILEB,12,MTYPE,A(IPNTA1),
     &                     A(IPNTA2),A(IPNTA3),SIGMA,
     &                     INRTIA,INFO)
C
              WRITE  (*,*) 'inrtia(1)                 :',INRTIA(1)
              WRITE  (*,*) 'inrtia(2)                 :',INRTIA(2)
              WRITE  (*,*) 'inrtia(3)                 :',INRTIA(3)
C
              CALL OUTPUT (A(IPNTA1),M(IPNTM2),NEQ)
C
      ELSE IF ( TEST .EQ. 'SKYSS'  ) THEN
C
C............ test SKYSS ...............................................
C
              OPEN  (5,ERR=3,FORM='formatted',FILE='driver.dat')
              READ  (5,FMT=*,ERR=3) (A(IPNTA4+I),I=0,NEQ-1)
              CLOSE (5,ERR=3)
C
              CALL SKYSS  (NEQ,NEQ,1,A(IPNTA1),A(IPNTA3),A(IPNTA4),
     &                     M(IPNTM2),M(IPNTM1),NBLOCK,
     &                     FILEF,11,INFO)
C
              OPEN  (6,ERR=3,FORM='formatted',FILE='driver.out')
              WRITE (6,FMT='(1P,E12.4)',ERR=4) (A(IPNTA4+I),I=0,NEQ-1)
              CLOSE (6,ERR=3)
C
      END IF
C
      STOP
    1 WRITE   (*,'(/A)') 'I/O error, file driver.par'
      STOP
    2 WRITE   (*,'(/A)') 'I/O error, file FINFO'
      STOP
    3 WRITE   (*,'(/A)') 'I/O error, file driver.dat'
      STOP
    4 WRITE   (*,'(/A)') 'I/O error, file driver.out'
      STOP
C
C.... end of DRIVER ....................................................
C
      END
C
C=======================================================================
C
      SUBROUTINE OUTPUT (A,DGPNT,NEQ)
C
      INTEGER          DGPNT(*),II,JJ,KK,NEQ
      DOUBLE PRECISION A(*)
C
      OPEN  (6,ERR=1,FORM='formatted',FILE='driver.out')
C
      WRITE (6,FMT='(2I5,1P,E25.15)',ERR=1) 1,1,A(1)
C
      DO 010 II = 2,NEQ
         KK = II - (DGPNT(II)-DGPNT(II-1))
         DO 020 JJ = DGPNT(II-1)+1,DGPNT(II)
            KK = KK + 1
            WRITE (6,FMT='(2I5,1P,E25.15)',ERR=1) KK,II,A(JJ)
  020    CONTINUE
  010 CONTINUE
C
      CLOSE (6,ERR=1)
C
      RETURN
C 
    1 WRITE   (*,'(/A)') 'I/O error, file driver.out'
      STOP
C
      END
